/* sf47r.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static real c_b8 = 0.f;
static integer c__1 = 1;
static integer c__47 = 47;

real sf47r_c(real *x, real *an, integer *ierr)
{
    /* Initialized data */

    static real anmin = .5f;
    static real sys089 = 1e-6f;
    static integer itmax = 20;
    static real sys059 = 3.4e38f;
    static real xmin = 1e-12f;
    static real amax = 40.f;

    /* System generated locals */
    integer i__1;
    real ret_val, r__1;

    /* Builtin functions */
    double sqrt(doublereal), log(doublereal), exp(doublereal);

    /* Local variables */
    static real dgam;
    extern /* Subroutine */ int sf23c_c(real *, real *, real *, real *, real *,
             integer *, integer *);
    extern real sf49r_c(real *);
    static real a, b;
    static integer i__;
    static real w, z__;
    extern /* Subroutine */ int utsf12_c(integer *, integer *);
    static real r1, w1, x1, z1, eps1;

    *ierr = 0;
    if (*an >= anmin) {
        goto L1;
    }
    *ierr = 65;
    goto L10;
L1:
    if (*x >= 0.f) {
        goto L2;
    }
    *ierr = 66;
    goto L10;
L2:
    if (*x > xmin) {
        goto L3;
    }
    ret_val = 0.f;
    goto L11;
L3:
    if (*an <= amax) {
        goto L4;
    }
    x1 = (real)sqrt((real)(*x + *x)) - (real)sqrt((real)(*an + *an - 1.f));
    ret_val = (real)sf49r_c(&x1);
    goto L11;
L4:
    a = *an * .5f;
    z__ = *x * .5f;
    eps1 = sys089;
    sf23c_c(&a, &c_b8, &dgam, &r1, &eps1, &c__1, ierr);
/* Computing MAX */
    r__1 = a * .5f;
    w = max(r__1,13.f);
    if (z__ >= w) {
        goto L7;
    }
    w = 1.f / (dgam * a);
    w1 = w;
    i__1 = itmax;
    for (i__ = 1; i__ <= i__1; ++i__) {
        b = (real) i__;
        w1 = w1 * z__ / (a + b);
        if (w1 <= sys089 * w) {
            goto L6;
        }
        w += w1;
/* L5: */
    }
L6:
    ret_val = w * (real)exp((real)(a * (real)log(z__) - z__));
    goto L11;
L7:
    z1 = 1.f / z__;
    b = a - 1.f;
    w1 = b * z1;
    w = w1 + 1.f;
    i__1 = itmax;
    for (i__ = 2; i__ <= i__1; ++i__) {
        b += -1.f;
        w1 = w1 * b * z1;
        if (w1 <= sys089 * w) {
            goto L9;
        }
        w += w1;
/* L8: */
    }
L9:
    w = z1 * (w * (real)exp((real)(a * (real)log(z__) - z__)));
    ret_val = 1.f - w / dgam;
    goto L11;
L10:
    utsf12_c(ierr, &c__47);
    ret_val = sys059;
L11:
    return ret_val;
} /* sf47r_c */
